//+------------------------------------------------------------------+
//|   #MTF_Hi_Low_Middle.mq4
//|   Base from spudfibo.Upgrade by Darkkiller
//:   Thanks to Mladen for helping me to make some correction
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "H4 Higher,Middle,Lower colors";
extern color H4HigherColor = DeepSkyBlue;
extern color H4MiddleColor = Yellow;
extern color H4LowerColor = HotPink;
extern string note2 = "Draw H4 Higher,Lower and Middle?";
extern bool  H4HiLow = true;
extern bool  H4Mid = true;

extern string note3 = "D1 Higher,Middle,Lower colors";
extern color D1HigherColor = DeepSkyBlue;
extern color D1MiddleColor = Yellow;
extern color D1LowerColor = HotPink;
extern string note4 = "Draw D1 Higher,Lower and Middle?";
extern bool  D1HiLow = true;
extern bool  D1Mid = true;


double HiPrice, LoPrice, Range, D1HiPrice, D1LoPrice, D1Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("H4Higher");
   ObjectDelete("H4Lower");
   ObjectDelete("H4Middle");
   
   ObjectDelete("D1Higher");
   ObjectDelete("D1Lower");
   ObjectDelete("D1Middle");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{

///////////////////////////////////////////HILO/////////////////////////////
if(H4HiLow)
	{

	if(ObjectFind("H4Higher") == -1)
		ObjectCreate("H4Higher",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("H4Higher",OBJPROP_TIME2, StartTime);
		ObjectSet("H4Higher",OBJPROP_TIME1, StartTime);
		ObjectSet("H4Higher",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("H4Higher",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("H4Higher",OBJPROP_LEVELCOLOR,H4HigherColor);
   ObjectSet("H4Higher",OBJPROP_FIBOLEVELS,1);
   ObjectSet("H4Higher",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("H4Higher",0,"H4 HIGHER-  %$"); 
   ObjectSet("H4Higher",OBJPROP_RAY,true);
   ObjectSet("H4Higher",OBJPROP_BACK,true);
   ObjectSet("H4Higher",OBJPROP_COLOR,EMPTY);


	if(ObjectFind("H4Lower") == -1)
		ObjectCreate("H4Lower",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("H4Lower",OBJPROP_TIME2, StartTime);
		ObjectSet("H4Lower",OBJPROP_TIME1, StartTime);
		ObjectSet("H4Lower",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("H4Lower",OBJPROP_PRICE2,LoPrice);
	

	}
   ObjectSet("H4Lower",OBJPROP_LEVELCOLOR,H4LowerColor); 
   ObjectSet("H4Lower",OBJPROP_FIBOLEVELS,1);
   ObjectSet("H4Lower",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("H4Lower",0,"H4 LOWER -  %$"); 
   ObjectSet("H4Lower",OBJPROP_RAY,true);
   ObjectSet("H4Lower",OBJPROP_BACK,true);
   ObjectSet("H4Lower",OBJPROP_COLOR,EMPTY);

	 }
  
  
  
if(D1HiLow)
	{

	if(ObjectFind("D1Higher") == -1)
		ObjectCreate("D1Higher",OBJ_FIBO,0,D1StartTime,D1HiPrice+D1Range,D1StartTime,D1HiPrice);
	else
	{
		ObjectSet("D1Higher",OBJPROP_TIME2, D1StartTime);
		ObjectSet("D1Higher",OBJPROP_TIME1, D1StartTime);
		ObjectSet("D1Higher",OBJPROP_PRICE1,D1HiPrice+D1Range);
		ObjectSet("D1Higher",OBJPROP_PRICE2,D1HiPrice);
	}
   ObjectSet("D1Higher",OBJPROP_LEVELCOLOR,D1HigherColor);
   ObjectSet("D1Higher",OBJPROP_FIBOLEVELS,1);
   ObjectSet("D1Higher",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("D1Higher",0,"H4 HIGHER-  %$"); 
   ObjectSet("D1Higher",OBJPROP_RAY,true);
   ObjectSet("D1Higher",OBJPROP_BACK,true);
   ObjectSet("D1Higher",OBJPROP_COLOR,EMPTY);


	if(ObjectFind("D1Lower") == -1)
		ObjectCreate("D1Lower",OBJ_FIBO,0,D1StartTime,D1LoPrice-D1Range,D1StartTime,D1LoPrice);
	else
	{
		ObjectSet("D1Lower",OBJPROP_TIME2, D1StartTime);
		ObjectSet("D1Lower",OBJPROP_TIME1, D1StartTime);
		ObjectSet("D1Lower",OBJPROP_PRICE1,D1LoPrice-D1Range);
		ObjectSet("D1Lower",OBJPROP_PRICE2,D1LoPrice);
	

	}
   ObjectSet("D1Lower",OBJPROP_LEVELCOLOR,D1LowerColor); 
   ObjectSet("D1Lower",OBJPROP_FIBOLEVELS,1);
   ObjectSet("D1Lower",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("D1Lower",0,"H4 LOWER -  %$"); 

   ObjectSet("D1Lower",OBJPROP_RAY,true);
   ObjectSet("D1Lower",OBJPROP_BACK,true);
   ObjectSet("D1Lower",OBJPROP_COLOR,EMPTY);

	 }  
  
/////////////////////////////////////////HILO/////////////////////////////	   
	   	   
/////////////////////////////////////////MIDDLE///////////////////////////
	
	if(H4Mid)
		if(ObjectFind("H4Middle") == -1)
			ObjectCreate("H4Middle",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_H4*60,LoPrice);
		else
		{
			ObjectSet("H4Middle",OBJPROP_TIME2, StartTime);
			ObjectSet("H4Middle",OBJPROP_TIME1, StartTime+PERIOD_H4*60);
			ObjectSet("H4Middle",OBJPROP_PRICE1,HiPrice);
			ObjectSet("H4Middle",OBJPROP_PRICE2,LoPrice);
	

		}
   	ObjectSet("H4Middle",OBJPROP_LEVELCOLOR,H4MiddleColor); 
   	ObjectSet("H4Middle",OBJPROP_FIBOLEVELS,1);
   	ObjectSet("H4Middle",OBJPROP_FIRSTLEVEL+0,0.500);	ObjectSetFiboDescription("H4Middle",0,"H4 MIDDLE -  %$"); 
   	ObjectSet("H4Middle",OBJPROP_RAY,true);
   	ObjectSet("H4Middle",OBJPROP_BACK,true);
   	ObjectSet("H4Middle",OBJPROP_COLOR,EMPTY);
  
}


	if(D1Mid)
		if(ObjectFind("D1Middle") == -1)
			ObjectCreate("D1Middle",OBJ_FIBO,0,D1StartTime,D1HiPrice,D1StartTime+PERIOD_D1*60,D1LoPrice);
		else
		{
			ObjectSet("D1Middle",OBJPROP_TIME2, D1StartTime);
			ObjectSet("D1Middle",OBJPROP_TIME1, D1StartTime+PERIOD_D1*60);
			ObjectSet("D1Middle",OBJPROP_PRICE1,D1HiPrice);
			ObjectSet("D1Middle",OBJPROP_PRICE2,D1LoPrice);
	

		}
   	ObjectSet("D1Middle",OBJPROP_LEVELCOLOR,D1MiddleColor); 
   	ObjectSet("D1Middle",OBJPROP_FIBOLEVELS,1);
   	ObjectSet("D1Middle",OBJPROP_FIRSTLEVEL+0,0.500);	ObjectSetFiboDescription("D1Middle",0,"D1 MIDDLE -  %$"); 
   	ObjectSet("D1Middle",OBJPROP_RAY,true);
   	ObjectSet("D1Middle",OBJPROP_BACK,true);
   	ObjectSet("D1Middle",OBJPROP_COLOR,EMPTY);
  
}
/////////////////////////////////////////MIDDLE///////////////////////////







//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+



int start()
{
	int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// H4 
	HiPrice		= iHigh(NULL,PERIOD_H4,shift);
	LoPrice		= iLow (NULL,PERIOD_H4,shift);
	StartTime	= iTime(NULL,PERIOD_H4,shift);
	
	D1HiPrice	 = iHigh(NULL,PERIOD_D1,shift);
	D1LoPrice	 = iLow (NULL,PERIOD_D1,shift);
	D1StartTime	 = iTime(NULL,PERIOD_D1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_H4,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_H4,shift+1));
		
		D1HiPrice = MathMax(D1HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
		D1LoPrice = MathMin(D1LoPrice,iLow(NULL,PERIOD_D1,shift+1));
	}

	Range = HiPrice-LoPrice;
   D1Range = D1HiPrice-D1LoPrice;
	DrawFibo();

	return(0);
}


//+------------------------------------------------------------------+

